#!/usr/bin/env perl
# $Header: /home/ed/source_control/psce/bin/EPQvScore.pl,v 1.3 2005/03/27 20:52:19 ed Exp $
# (c) 2002 Ed Green, UC Regents

use strict;
use FamNorm;
use Getopt::Std;
use vars qw( $opt_a $opt_f );

MAIN : {
    
    &init();
    
    my $fno = FamNorm->new( $opt_a );

    my $num_queries = $fno->totalEntries();

    open( FP_FILE, $opt_f ) or die( "$!: $opt_f" );
    
    # Since every line is an error (a false positive), we'll increment
    # this by one for each line 
    my $errors = 0;
    my ( $score, $old_score, $epq );

    while ( <FP_FILE> ) {
	print( "# EPQ Score\n" ); 
	$errors++;
	( $score = &processLine( $_ ) );

	unless ( $score == $old_score ) {
	    $epq = $errors / $num_queries;
	    print ( substr( $epq, 0, 8 ),
		    " $score\n" ); 
	    $old_score = $score;
	}
    }
}

sub processLine {
    my $line = shift;
    my @el = split( /\s+/, $line );
    return $el[ 2 ];
}

sub init {
    getopts( 'a:f:' );
    unless ( $opt_a && $opt_f ) {
	print( "EPQvScore.pl\n" );
	print( "Generates data showing how many errors were made\n" );
	print( "each significance score level.\n" );
	print( "OPTIONS:\n" );
	print( "-a [ ASTRAL database file for this search ]\n" );
	print( "-f [ File of false positives ]\n" );
	exit( 0 );
    }
}
