#!/usr/bin/env perl
# $Header: /home/ed/source_control/psce/bin/cve_automator.pl,v 1.2 2005/03/27 20:52:20 ed Exp $
# (c) 2002 Gavin Price

use strict;

use Getopt::Std;
use vars qw( $opt_i $opt_n $opt_s $opt_d $opt_c );

my ( $i, $test_fn, $suffix, $cmd, $status );

&init();

$test_fn = "$opt_d/$opt_i.bbs.1";
if ( $opt_s ) {
    $suffix = ".$opt_s";
    $test_fn .= $suffix;

}

if ( -f $test_fn ) {
    for ($i = 1; $i <= $opt_n; $i++) {
	$cmd = 
	    ( "cve_maker.pl -i $opt_d/$opt_i.bbs.$i$suffix -o $opt_c/$opt_i.bbs.$i.dat" );
	$status = system( $cmd );
	if ( $status ) {
	    warn( "$cmd\nfinished with status $status\n" );
	}	    
    }
}

else {
    print( "Can not find $test_fn\nPlease check your options and try again.\n" );
    exit( 1 );
}


sub init {
    getopts( 'i:n:s:d:c:' );
    unless( $opt_i && $opt_n && $opt_d && $opt_c ) {
	print ( "cve_automator.pl\n" );
	print( "This program automates running cve_maker multiple times\n" );
	print( "on bootstrap replicate dbvdbsum data.\n" );
	print( "OPTIONS:\n" );
	print( "-i [ root of filname ]\n" );
	print( "-n [ number of bootstrap files .n. ]\n" );
	print( "-s [ filename suffix, like bz2 ]\n" );
	print( "-d [ directory where bootstrap files are ]\n" );
	print( "-c [ directory to write the cve data files to ]\n" );
	print( "Files are assembled like [opt_i].bbs.[opt_n].[opt_s]\n" );
	exit( 0 );
    }
}
