#!/usr/bin/env perl
# $Header: /home/ed/source_control/psce/bin/e_finder.pl,v 1.2 2005/03/27 20:52:20 ed Exp $
#Note: slightly modified version of Ed's cve_maker.pl. Therefore, probably not as efficient
#as it could be, but it's good enough for government work.

use strict;
use Getopt::Std;
use DBVDB;
use vars qw( $opt_i $opt_v $opt_e $opt_h $opt_l $opt_d); #took out $opt_o here and in &init

MAIN : {
 
    my ( $dbo, $sig, $hit, $hit_p, $epq, 
	 $qdb_size, $tdb_size, $errors );

    my ( @cve, $query_rels, $target_rels, @cov );

    my ($eValue, $error_cve, $cve_index, $last_eValue, $hitref); #hack

    &init();
    
    $errors = 0;
    
    $dbo = new DBVDB( $opt_i );
    $qdb_size = $dbo->numQueries();
    $tdb_size = $dbo->numTargets();
    $query_rels = $dbo->numQueryRels();
    $target_rels = $dbo->numTargetRels();

    foreach $sig ( $dbo->sigs() ) {
	$hit_p = $dbo->hitsAtSig( $sig );
	$eValue = $hit_p->[0]->[2];  #hack
	$errors = 
	    &examineHits( $hit_p, $errors, \@cov, $query_rels,
			  $target_rels );
	&updateCVE( $errors, $qdb_size, \@cov, \@cve );
	my $tmp = $cve[0];                       #hack
	$cve_index = (scalar @$tmp) - 1;         #hack
	$error_cve = $cve[0]->[$cve_index]->[1]; #hack
	if ($opt_l) {print "EPQ = $error_cve; E-Value = $eValue;\n";} #hack
	if ($error_cve >= $opt_e) {                #hack
	    if(!$opt_d) {
		print "\nE-Value just prior to EPQ of $error_cve is $last_eValue\n";
	    }
	    exit(0);
	}
	if ($opt_h or $opt_v) { #hack
	    # code to print hits/fps to std.out
	    foreach $hitref (@{$hit_p}) {
		my $hit1 = $hitref->[0];
		my $hit2 = $hitref->[1];
		my $match = $hitref->[3];
		if($opt_h and $match == 3           ) {
		    print "$hit1 $hit2 $eValue $match\n";
		}
		if($opt_v and ($match == 0 or $match == 1)) {
		    print "$hit1 $hit2 $eValue $match\n";
		}
	    }
	}
	$last_eValue = $eValue;                  #hack
    }
    print "\nEPQ greater than $opt_e not found\n";
    #&makeDataFile( \@cve ); 
}

sub examineHits {
    my $hit_p = shift;
    my $errors = shift;
    my $cov_p = shift;
    my $qr_p = shift;
    my $tr_p = shift;;
    my $rel;
    my ( $hit );
    foreach $hit ( @{ $hit_p } ) {
	$rel = &related( $hit );
	if ( $rel == 1 ) {
	    &addToCov( $cov_p, $hit, $qr_p, $tr_p );
	}
	elsif ( $rel == -1 ) {
	    $errors++;
	    #if ( $opt_v ) {
		#&showError( $hit );
	    #}
	}
	else {
	    # undecided, rel == 0, do nothing
	}
    }
    return $errors;
}

sub related {
    my $hit = shift;
    if ( $hit->[ 3 ] == 3 ) {
	return 1;
    }
    elsif ( $hit->[ 3 ] == 2 ) {
	return 0;
    }
    else {
	return -1;
    }
}

sub addToCov {
    my $cov_p = shift;
    my $hit = shift;
    my $qr_p = shift;
    my $tr_p = shift;
    
    #if ( $opt_p ) {
	# Profile method, only do linear normalization
	#$cov_p->[ 0 ] += $hit->[ 4 ] / $tr_p->[ 0 ];
	#$cov_p->[ 1 ] += $hit->[ 5 ] / $tr_p->[ 1 ];
    #}
    
    #else {
	# Query database = target database
	$cov_p->[ 0 ] += $hit->[ 4 ] / $qr_p->[ 0 ];
	$cov_p->[ 1 ] += $hit->[ 5 ] / $qr_p->[ 1 ];
	$cov_p->[ 2 ] += $hit->[ 6 ] / $qr_p->[ 2 ];
    #}
}

sub showError {
    my $hit = shift;
    my $qid = $hit->[ 0 ];
    my $tid = $hit->[ 1 ];
    my $sig = $hit->[ 2 ];
    my $rel = $hit->[ 3 ];

    print( "$qid $tid $sig $rel\n" );
}

sub updateCVE {
    my $errors = shift;
    my $qdb_size = shift;
    my $cov_p = shift;
    my $cve_p = shift;
    push( @{$cve_p->[ 0 ]}, [ $cov_p->[ 0 ], $errors/$qdb_size ] );
    push( @{$cve_p->[ 1 ]}, [ $cov_p->[ 1 ], $errors/$qdb_size ] );
    push( @{$cve_p->[ 2 ]}, [ $cov_p->[ 2 ], $errors/$qdb_size ] );
}

#sub makeDataFile {
#    my $cve_p = shift;
 #   my ( $point, 
#	 $cov, 
#	 $epq, 
	# $cov_m1, 
	# $epq_m1,
	 #$cov_m2, 
	 #$epq_m2 ) = 
	#     ( 0, 0, 0, 0, 0, 0, 0 );
    #open( OUTFILE, ">$opt_o" ) or die( "$opt_o: $!" );
    #print OUTFILE ( "# Unnormalized CVE data\n" );

    #foreach $point ( @{ $cve_p->[ 0 ] } ) {

	#( $cov_m1, $epq_m1, $cov_m2, $epq_m2 ) = 
	 #   ( $cov, $epq, $cov_m1, $epq_m1 );
	
	#( $cov, $epq ) = ( $point->[ 0 ], $point->[ 1 ] );
	
	#if ( &showPoint( $cov, $epq, $cov_m1, $epq_m1, 
		#	 $cov_m2, $epq_m2 ) ) {
	   # print OUTFILE ("$cov_m1 $epq_m1\n" );
	#}
    #}
    #print OUTFILE ( "$cov $epq\n" );
    #print OUTFILE ( "\n\n" );
    
    #( $point, $cov, $epq, $cov_m1, $epq_m1, $cov_m2, $epq_m2 ) = 
#	( 0, 0, 0, 0, 0, 0, 0 );
 #   print OUTFILE ( "# Linearly normalized CVE data\n" );
#
 #   foreach $point ( @{ $cve_p->[ 1 ] } ) {
#
	#( $cov_m1, $epq_m1, $cov_m2, $epq_m2 ) = 
	 #   ( $cov, $epq, $cov_m1, $epq_m1 );
	#
	#( $cov, $epq ) = ( $point->[ 0 ], $point->[ 1 ] );
	#
	#if ( &showPoint( $cov, $epq, $cov_m1, $epq_m1, 
		#	 $cov_m2, $epq_m2 ) ) {
	   # print OUTFILE ("$cov_m1 $epq_m1\n" );
	#}
    #}
   # print OUTFILE ( "$cov $epq\n" );
   # print OUTFILE ( "\n\n" );
    
   # ( $point, $cov, $epq, $cov_m1, $epq_m1, $cov_m2, $epq_m2 ) = 
	#( 0, 0, 0, 0, 0, 0, 0 );
    #print OUTFILE ( "# Quadratically normalized CVE data\n" );
    #foreach $point ( @{ $cve_p->[ 2 ] } ) {

	#( $cov_m1, $epq_m1, $cov_m2, $epq_m2 ) = 
	 #   ( $cov, $epq, $cov_m1, $epq_m1 );
	
	#( $cov, $epq ) = ( $point->[ 0 ], $point->[ 1 ] );
	
	#if ( &showPoint( $cov, $epq, $cov_m1, $epq_m1, 
		#	 $cov_m2, $epq_m2 ) ) {
	    #print OUTFILE ("$cov_m1 $epq_m1\n" );
	#}
    #}
    #print OUTFILE ( "$cov $epq\n" );
    #close OUTFILE
#}

sub showPoint {
    my $cov = shift;
    my $epq = shift;
    my $cm1 = shift;
    my $em1 = shift;
    my $cm2 = shift;
    my $em2 = shift;
    
#    return 1;

    unless ( ($cov == $cm1 && $cm1 == $cm2) ||
	     ($epq == $em1 && $em1 == $em2) ) {
	return 1;
    }
    else {
	return 0;
    }
}

sub init {
    getopts( 'i:ve:hld' );
    unless ( $opt_i && $opt_e) {
	print( "e_finder.pl\n" );
	print( "Examines a dbvdb file and outputs the E-Value at a particular EPQ\n" );
	print( "OPTIONS:\n" );
	print( "-i [ Input dbvdb output file ]\n" );
	#print( "-o [ Output CVE file ]\n" );
	#print( "-p [ Profile method results ]\n" );
	print( "-v : verbose mode; report false positives\n");
	print( "-l : list EPQs & E-Values up to cutoff\n" );
	print( "-h : print hits below cutoff to std out\n");
	print( "-d : don't print final EPQ and E-Value\n");
	print( "-e [ EPQ cutoff for which to report E-Value ]\n");
	exit( 0 );
    }
    #unless ( $opt_o ) {
#	$opt_o = "$opt_i.dat";
 #   }
}
