#!/usr/bin/env perl
# $Header: /home/ed/source_control/psce/bin/seq_diff.pl,v 1.2 2005/03/27 20:52:20 ed Exp $

# (c) 2002 Gavin Price


use strict;

use Getopt::Std;
use vars qw( $opt_i $opt_j);

my ($l, @l, %fileData, $filename);
&init();

for $filename ($opt_i, $opt_j) {
    open(FILE, "<$filename") or die ("Can't open file $filename: $!");
    while (chomp($l = <FILE>)) {
	@l = split /\s+/, $l;
	$fileData{$filename}->{$l[0]}->{$l[1]} = 1;
    }
    close FILE;
}

open(FILE, "<$opt_i") or die ("Can't open file $opt_i: $!");
while (chomp($l = <FILE>)) {
    @l = split /\s+/, $l;
    if($fileData{$opt_j}->{$l[0]}->{$l[1]} == undef) {
	print "$opt_i unique record: $l\n";
    }
}

open(FILE, "<$opt_j") or die ("Can't open file $opt_j: $!");
while (chomp($l = <FILE>)) {
    @l = split /\s+/, $l;
    if($fileData{$opt_i}->{$l[0]}->{$l[1]} == undef) {
	print "$opt_j unique record: $l\n";
    }
}

sub init {
    getopts( 'i:j:' );
    unless( $opt_i and $opt_j) {
	print( "seq_diff.pl\n" );
	print( "Compares two files containing only sequence hits, similar to a dbvdbfile,\n" );
	print( "but with only the sequences. Prints sequences which are not in both files.\n" );
	print( "Typical use is for detecting unique sequences from the output of e_finder.pl\n" );
	print( "runs on different dbvdb files.\n" );
	print( "OPTIONS:\n" );
	print( "-i [ the first file ]\n" );
	print( "-j [ the second file ]\n" );
	exit( 0 );
    }
}
